<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">

<HTML>

<HEAD>
<TITLE>Votre devoir</TITLE>
<script language="JavaScript">
function msg(x) {alert(x);
}
</script>
<style TYPE="text/css">
body {background-color: #0000a0; color:#ffff80; font-size:14pt}
A:link {color: #80ff00}
A:visited {color: #ff80c0}
A:active {color: #ff0000}
h1 {text-align:center; font-size:24pt}
h2 {text-decoration:underline; font-size:18pt}
tt {font-weight:bold; color:#D0C070;}
pre {font-weight:bold; color:#D0C070; font-size:16pt;}
.nrm {color:#ffff80;}
em {font-weight:bold; color:#FFc000}
.gr {font-weight:bold; color:#80FFA0; font-family:helvetica,arial}
.bi {font-weight:bold; color:#80FFA0; font-family:helvetica,arial; font-size:20pt}
.ib {font-weight:bold; font-style:italic}
table td {color: #ffff80; font-size:16pt }
</style>
</HEAD>

<BODY>
<font color="#ffff80">
<H1>Votre devoir de compilation, 1999/<A HREF="javascript:alert('Bug 2K finalement corrigé...')">2000</A></H1>
<P>

<CENTER>
<table width=50%>
<tr>
<td><IMG SRC="../icons/starroll.gif"></td>
<td><IMG SRC="../icons/spinstar.gif"></td>
<td><IMG SRC="../icons/starroll.gif"></td>
</tr></table>

<p>
<span class="bi">Affichage 2-dimensionnel des expressions algébriques</span>
<p>

</CENTER>
<P>



<H2>Introduction, l'énoncé du sujet</H2>
<P>

Écrire <EM>en Haskell</EM> un parseur d'expressions algébriques qui génère un "code" particulier : les mêmes expressions, mais formatées en deux dimensions, avec les indices qui descendent, exposants élévés, fractions représentés par des tableaux verticaux - (numérateur, barre, dénominateur superposés), avec les parenthèses dont la taille s'adapte à la hauteur des sous-expressions parenthésées, etc.
<p>

Pour simplicité, le formatage n'utilisera aucune police non-standard ni aucun paquetage extérieur. Le programme doit lire un fichier avec une ou plusieurs expressions, et afficher sur l'écran (ou sur un fichier extérieur) l'expression résultante en ANSI, où le positionnement sera assuré par l'ajout des espaces et sauts de ligne.
<p>

<a name="bidim"> </a>
Voici un exemple de résultat :
<PRE>
  /      2        \
  | alpha  + x    |
  |           i,j |
  | ------------- | + beta/2
  \    sin(2 y)   /
</PRE>
Le résultat - évidemment - ne sera pas idéal, mais suffisant.
<p>

<H2>Langage-source</H2>

Voici les éléments du langage qui doivent être pris en compte. <EM>Faites attention !</EM> Il ne s'agit pas de construire l'arbre syntaxique en fonction des priorités des opérateurs, et le parenthésage ne joue pas le même rôle que dans le cas d'exécution des opérations arithmétiques! Les parenthèses "normales" 
doivent tout simplement être affichées, la complexité vient du fait qu'elles doivent apparaître en paires bien construites, et que leur taille est ajustable. Par contre, les accolades (invisibles) servent de caractères de groupement, par exemple il faudra mettre <B>{i,j}</B> entre les accolades, si ce groupe constitue l'indice.
<p>
 
Le parseur doit en première instance éliminer les espaces et fins de ligne du texte source.
<p>

Les éléments lexicaux sont :
<OL type="A">
<LI> Les identificateurs, les nombres entiers, ou flottants, sans, ou avec signes. <SPAN class=ib>N'essayez pas de construire les valeurs numériques des nombres !</SPAN> Cela ne sert à rien, les nombres comme les noms doivent tout simplement être affichés.
<p>

<LI> Les opérateurs additifs "+" et "-" qui seront séparés par des espaces de ses arguments.
<p>

<LI> Les opérateurs multiplicatifs : "*" qui se transformera en espace, et "/' qui sera affiché tel quel, sans espaces. Il ne construit pas les fractions !
<p>

<LI> L'opérateur "//", obligatoire pour former les fractions, et transformer <B>a//beta</B> en 
<div>
<TABLE><TR><TD>&nbsp;&nbsp;a</TD></TR><TR><TD>----</TD></TR><TR><TD>beta</TD></TR></TABLE>
</div>, etc. <EM>Attention :</EM> Comment grouper les arguments de l'opérateur "//", quelle est sa portée? <br>
On considère "//" comme un opérateur de très faible précédence, et non-associatif, c'est à dire qu'il "avale" tout (dans la zone spécifiée par "<B>{... // ...}</B>") à gauche (numérateur) et à droite (dénominateur), et que la construction "a//b//c" est illégale. On doit toujours délimiter les arguments par les accolades, par exemple "{a//{b//c}}".
<p>

<LI> La virgule, affichée telle quelle.
<LI> L'opérateur d'indice "_" (<I>underscore</I>).
<p>

<LI> Opérateur d'exposant "^". Avec l'indice cet opérateur a la plus forte précédence.
<p>

<lI> Les paires de parenthèses "(",")" qui doivent être "légales" au sens habituel, mais qui ne font pas de groupement.
<p>

<LI> Les accolades qui délimitent les sous-expressions. 
</OL>
La source de notre <A HREF="#bidim">expression exemplaire</A> pourrait être
<PRE>
({alpha^2 +x_{i,j}//sin(2*y )})+ beta/2
</PRE>
Les identificateurs adjacents : "<TT>alpha beta</TT>" sont équivalents à "<TT>alpha*beta</TT>". Les accolades et les parenthèses redondantes sont permises, mais toujours en paires bien formées.
<p>

Le parseur doit prévoir le minimum de reconnaissance de fautes comme "a+", ou "x/*g".
<p>

<H2>Technique du parsing attribué, et boîtes géométriques</H2>

<SPAN class=ib>Ce sujet (les attributs) sera décrit en cours.</SPAN> Un parseur universel, avec quelques procédures sémantiques attachées aux entités strictement grammaticales, transforme l'objet reconnu en morceau de "code". Ainsi il peut faire une liste, un entier, ou un flottant, etc.
<p>

Jusqu'à présent nous avons considéré le parseur d'expressions comme un module qui transforme un texte linéaire en un arbre dont la structure détermine l'ordre des évaluations. Ici il n'y a pas d'"évaluation" proprement dite. L'expression est "codée" sous forme de boîtes rectangulaires, remplies par le contenu spécifié par la source. Chaque boîte est une structure de données qui possède les propriétés suivantes :
<p>
<CENTER><IMG SRC="boitev.gif"></CENTER>
<p>

<UL>
<LI> Le <SPAN class=ib>Contenu</SPAN> qui peut être un simple texte (identificateur, nombre ou un opérateur visible, éventuellement la barre de fraction "----" composée de tirets, mais qui peut être également une collection de boîtes imbriquées. (Donc, la définition d'une boîte est récursive.)
<p>

<LI> Les propriétés géométriques : <SPAN class=ib>Hauteur, Largeur</SPAN> et <SPAN class=ib>Profondeur</SPAN>. Un simple texte n'a pas de profondeur, celle-là est différente de zéro dans le cas des fractions (dénominateur), ou en présence des indices.
<p>

<LI> La "position de la boîte" est determinée par la position de son <EM>point de base</EM>, l'extrémité gauche de la <SPAN style="color:#FF9090">Ligne de base</SPAN>. Chaque boîte possède l'attribut : <SPAN class=ib>position par rapport à sa boîte mère</SPAN> : <SPAN class=ib>(px,py)</SPAN>.
</UL>

Le parseur doit pendant l'analyse reconstruire les propriétés des boîtes. Pour deux ou plusieurs items qui se suivent :<TT>alpha beta gamma</TT>, le parseur construira la boîte englobante, dont la largeur - naturellement - est la somme des largeurs des composantes, et la hauteur (profondeur) est le maximum des hauteurs (profondeurs) des composantes. Les lignes de base doivent être alignées. Le point de base de <TT>alpha</TT> se confond avec le point de base de la boîte englobante (donc, <SPAN class=ib>px=0, py=0</SPAN>). Le p.d.b. de <TT>beta</TT> possède la valeur : <SPAN class=ib>px=largeur(alpha), py=0</SPAN>.
<p>

Pour la puissance <TT>alpha<SUP>beta</SUP></TT> les largeurs et les hauteurs s'additionnent, la profondeur totale est la profondeur de <TT>alpha</TT>. 
<p>

Pour les fractions le p.d.b. de la boîte globale est le p.d.b. de la barre. Elle-même, ainsi que le numérateur contribuent à la hauteur, et le dénominateur - à la profondeur. La largeur de la fraction est le maximum de deux largeurs, et <B>la largeur de la barre s'adapte</B>. Les deux sous-champs sont centrés sur/sous la barre. 
<p>

De la même façon la hauteur des parenthèses s'adapte aux dimensions de l'expression parenthésée, mais ici accessoirement le p.d.b. devient un peu variable, car les parenthèses peuvent entourer des fractions très différentes - numérateur plus haut que le dénominateur, ou vice-versa.
<p>

Pour d'autres constructions, avec indices, etc. découvrez vous-mêmes les relations entre les propriétés géométriques des composantes et les boîtes englobantes. <EM>Notez bien !</EM> Les dimensions de la boîte englobante sont héritées des composantes, mais les positions des boîtes internes sont synthétisées à partir de la position de la boîte "mère" et des voisins.

<H2>Organisation du programme</H2>

Utiliser les fonctions <TT>readFile</TT> pour la lecture, et <TT>putStr</TT> ou <TT>writeFile</TT> pour l'écriture du résultat. Mais le parseur doit être indépendant de l'interface de lecture, on doit pouvoir le tester intéractivement, en lui passant une chaîne qui représente l'expression.
<p>

Vous <B>n'êtes pas obligés</B> d'utiliser les parseurs monadiques, mais je vous déconseille de bricoler quelque chose d'autre... 
<p>

Le programme sera composé de deux modules indépendants. Le parseur construit la "boîte", et passe le résultat au module suivant qui s'occupe de l'affichage.
<p>

Ce module détruit les boîtes, et reconstruit le texte avec espaces et sauts de ligne interspersés. Il commence par aplâtir les boîtes, par les éliminer toutes, sauf les boîtes internes, dont le contenu est déjà textuel. Pour chacune des boîtes textuelles sa position doit devenir <SPAN class=ib>absolue</SPAN> (relative par rapport à la page). Ces boîtes peuvent être mises dans une liste, et triées d'abord dans l'ordre croissant selon la ligne d'affichage, ensuite, sur la même ligne - selon la colonne.

</font>
</BODY>
</HTML>
